"use strict";

/**
 * Created by zolee on 2016. 10. 11..
 */

(function () {

    if (!window && !window.$)
        return;
    if (!window.Modernizr)
        return;

    var btnAddToCart = {};
    var btnEmptyCart = {};
    var btnSendCart = {};
    var imgSpinner = {};

    function isValidEmail(email) {
        var re = /^(([^<>()\[\]\.,;:\s@\"]+(\.[^<>()\[\]\.,;:\s@\"]+)*)|(\".+\"))@(([^<>()[\]\.,;:\s@\"]+\.)+[^<>()[\]\.,;:\s@\"]{2,})$/i;
        return re.test(email);
    }

    $(function () {
        var buttons = $(".row.toolbar.toolbar-position-top > * > .btn.btn-sm.button-update") || [];
        var buttonBar = $("#top-toolbar");

        $(document.body).prepend(
            '<div id="dialog" title="E-Mail Küldés">' +
            '    <form>' +
            '        <fieldset>' +
            '            <div class="ui-field-contain">' +
            '                <label for="email01" style="padding-right: 0.5em;">E-mail</label>' +
            '                <input type="text" name="email01" id="email01" class="ui-email-field" size="30">' +
            '            </div>' +
            '            <div class="ui-field-contain" style="height:6px;"></div>' +
            '            <div class="ui-field-contain">' +
            '                <label for="email02" style="padding-right: 0.5em;">E-mail</label>' +
            '                <input type="text" name="email02" id="email02" class="ui-email-field" size="30">' +
            '            </div>' +
            '        </fieldset>' +
            '    </form>' +
            '</div>'
        );

        var emailDlg = $("#dialog").dialog({
            autoOpen: false,
            modal: true,
            width: 320,
            buttons: [
                {
                    text: "Küldés",
                    click: function() {
                        var e0 = $("#email01", this).val();
                        var e1 = $("#email02", this).val();

                        onKKSendCart(e0, e1);

                        $(this).dialog("close");
                    }
                },
                {
                    text: "Mégsem",
                    click: function() {
                        $(this).dialog("close");
                    }
                }
            ],
            open: function (event, ui) {
                $(".widget button", this)
                    .eq(0).button({disabled:true}).end()
                    .eq(1).button().end()
                ;
            }
        });

        $(buttonBar).append("<button id='btn-kk-add-to-cart' class='btn btn-sm button-kklogic-add-to-cart'><img src='assets/images/cart_add.png' width='16px' height='16px'>&nbsp;<span class='btn-label btn-label-right'>Kosárba</span></button>")
        $(buttonBar).append("<button id='btn-kk-empty-cart' class='btn btn-sm button-kklogic-empty-cart'><img src='assets/images/cart_empty.png' width='16px' height='16px'>&nbsp;<span class='btn-label btn-label-right'>Kosár kiürítése</span></button>")
        $(buttonBar).append("<button id='btn-kk-send-cart' class='btn btn-sm button-kklogic-send-cart'><span class='glyphicon glyphicon-send'></span><span class='btn-label btn-label-right'>Kosár elküldése</span><span id='kk-spinner' style='padding-left: 12px; display: none'><img src='assets/images/ajax-loader.gif'></span></button>")

        var form = $("#formc") || [];
        form.css("z-index", 10);

        btnAddToCart = $("#btn-kk-add-to-cart");
        btnEmptyCart = $("#btn-kk-empty-cart");
        btnSendCart = $("#btn-kk-send-cart");
        imgSpinner = $("#kk-spinner");

        window.KKCart = new KKCart();

        updateCartInfo();

        btnAddToCart.on("click", function () {
            onKKAddToCart();
            updateCartInfo();
        });

        btnEmptyCart.on("click", function () {
            onKKEmptyCart();
            updateCartInfo();
        });

        btnSendCart.on("click", function () {
            //onKKSendCart();
            $("#dialog").dialog("open");
        });
    });

    /*
     */
    function updateCartInfo() {
        var ic = window.KKCart.itemCount();

        if (ic > 0) {
            $("span", btnEmptyCart).text("Kosár kiürítése (" + ic + ")");

            btnEmptyCart.removeAttr("disabled");
            btnSendCart.removeAttr("disabled");
        } else {
            $("span", btnEmptyCart).text("Kosár kiürítése");

            btnEmptyCart.attr("disabled", "disabled");
            btnSendCart.attr("disabled", "disabled");
        }
    }

    /*
     */
    function onKKAddToCart() {
        // TAB Based
        /*
        var tabHeads = $("#formc [role=navigation] ul.nav-tabs");
        var activeHeadText = $("li.active > a", tabHeads).text();

        var tab = $("#tab");
        var activeTab = $(".active", tab);
        var fields =  $("select, input", activeTab);

        var item = { "product" : activeHeadText };

        item.data = $.makeArray(fields.map(function () {
            var p = $(this);

            if (this.tagName === "SELECT") {
                p = $(this).parent().parent().parent();
            } else if (this.tagName === "INPUT") {
                p = $(this).parent().parent();
            }

            var prefix = $("td:first", p).text().trim();
            var suffix = $("td:last", p).text().trim();

            console.log("" + $(this).attr("id") + ": " + prefix + " = " + $(this).val() + " " + suffix);
            return {
                'key' : $(this).attr("id"),
                'value' : prefix + " = " + $(this).val() + " " + suffix
            };
        }));

        window.KKCart.addItem(item);
        */


        // Accordion based
        var subDocuments = $.map(
            $("iframe", $("#categories")).filter(":visible") || [],
            function (f) {
                return f.contentDocument;
            });

        var articles = $("article", subDocuments).filter(":visible") || [];
        if (articles.length != 1)
            return;

        var article = articles[0];
        var section = $(article.parentElement);
        var header = $("header > a:first-child", section);
        var panel = $("table", section);
        var fields =  $("select, input", panel);

        var rows = $("tr:has(select), tr:has(input)", panel).filter(function(i, r) {
            return r.children && (r.children.length == 3 || r.children.length == 1);
        });

        //var item = { "product" : (header.text() || "").trim() };

        var item = "Termék : " + (header.text() || "").trim() + "\n";

        function cellData(cell) {
            var e =  $("select, input", cell);
            if (e && e.length == 1)
                return e.val();

            return $(cell).text().trim();
        }

        item += $.makeArray(rows.map(function () {

            if (this.children.length == 1) {
                var e =  $("select, input", this);
                if (e && e.length == 1)
                    return e.val();
                else
                    return e.text().trim();

                return cellData(this.children[0]);
            }

            var r = "";
            for (var ci = 0; ci < this.children.length; ++ci) {
                r += cellData(this.children[ci]);

                r += (ci == 0) ? " = " : " ";
            }
            return "    " + r.trim();
        })).join("\n");

        // item += $.makeArray(fields.map(function () {
        //     var p = $(this);
        //
        //     if (this.tagName === "SELECT") {
        //         p = $(this).parent().parent().parent();
        //     } else if (this.tagName === "INPUT") {
        //         p = $(this).parent().parent();
        //     }
        //
        //     var prefix = $("td:first", p).text().trim();
        //     var suffix = $("td:last", p).text().trim();
        //
        //     console.log("" + $(this).attr("id") + ": " + prefix + " = " + $(this).val() + " " + suffix);
        //     // return {
        //     //     'key' : $(this).attr("id"),
        //     //     'value' : prefix + " = " + $(this).val() + " " + suffix
        //     // };
        //     return "    " + prefix + " = " + $(this).val() + " " + suffix;
        // })).join("\n");

        window.KKCart.addItem(item);
    }

    /*
     */
    function onKKEmptyCart() {
        window.KKCart.makeEmpty();
    }

    /*
     */
    function onKKSendCart(e0, e1) {

        e0 = e0 || "";
        e1 = e1 || "";

        e0 = isValidEmail(e0) ? e0 : "";
        e1 = isValidEmail(e0) ? e1 : "";

        if (e0.length == 0 && e1.length == 0)
            return;

        var mail = "<html><head></head><body>Ez lesz az <b>értesítő</b> e-mail.</body></html>";
        var b64 = btoa(encodeURIComponent(mail));

        //b64 = btoa(encodeURIComponent(JSON.stringify(window.KKCart.items().join("\n\n"))));
        b64 = btoa(encodeURIComponent(window.KKCart.items().join("\n\n")));

        var sender = "http://logickft.domain.com/logickft/lic/kkmailer.php?key=KKDEVELOPMENT";
        if (e0.length != 0)
            sender += "&e0=" + e0;
        if (e1.length != 0)
            sender += "&e1=" + e1;

        disableControls();
        imgSpinner.show();

        $.ajax(encodeURI(sender), {
            async : true,
            type : 'POST',
            data: { cart : b64 },
            success : function (data, status) {
                var response = JSON.parse("" + (data || '{ "status" : false }'));
                if (response && response.status) {
                    onKKEmptyCart();

                    $.notifyBar({
                        cssClass: "success",
                        html: "Köszönjük érdelődését, munkatársunk hamarosan jelentkezik Önnél.",
                        close: true,
                        delay: 6000
                    });
                }
                else {
                    $.notifyBar({
                        cssClass: "error",
                        html: "A küldés nem sikerült. Próbálja meg később.",
                        close: true,
                        delay:5000
                    });
                }
            },
            error : function (xhr, status) {
                $.notifyBar({
                    cssClass: "error",
                    html: "A küldés nem sikerült. Próbálja meg később.",
                    close: true,
                    delay:5000
                });
            },
            complete : function () {
                imgSpinner.hide();

                enableControls();
                updateCartInfo();
            }
        });
    }

    function disableControls() {
        disableControl(btnAddToCart);
        disableControl(btnEmptyCart);
        disableControl(btnSendCart);
    }

    function enableControls() {
        enableControl(btnAddToCart);
        enableControl(btnEmptyCart);
        enableControl(btnSendCart);
    }

    function disableControl(control) {
        control.prop('disabled', true);
    }

    function enableControl(control) {
        control.prop('disabled', false);
    }

    /*
     */
    function KKCart() {
        this._entries = [];
        this._storageName = "KKSessionData";

        this.loadFromStorage();
    }

    KKCart.prototype.itemCount = function() {
        return this._entries.length;
    };

    KKCart.prototype.items = function() {
        return this._entries;
    };

    KKCart.prototype.addItem = function(item) {
        //if (item && Object.prototype.toString.call(item) === '[object Object]') {
            this._entries.push(item);
            this.saveToStorage();
        //}
    };

    KKCart.prototype.makeEmpty = function() {
        this._entries = [];
        this.saveToStorage();
    };

    KKCart.prototype.saveToStorage = function() {
        if (window.Modernizr.sessionstorage) {
            window.sessionStorage.setItem(this._storageName, encodeURIComponent(JSON.stringify(this._entries)));
        }
    };

    KKCart.prototype.loadFromStorage = function() {
        if (window.Modernizr.sessionstorage) {
            var json = window.sessionStorage.getItem(this._storageName);
            if (!json)
                return;
            json = JSON.parse(decodeURIComponent(json));
            if (json && Object.prototype.toString.call(json) === '[object Array]') {
                this._entries = json;
            }
        }
    };
})();
